------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2009 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt4.Menus;
with Qt4.Text_Documents;
with Qt4.Text_Formats;
with Qt_Ada.Internals.Object_Registry;
with Qt_Ada.Internals.Objects;

with Qt_Ada.Internals.Objects.Plain_Text_Edit_Proxies;
pragma Warnings (Off, Qt_Ada.Internals.Objects.Plain_Text_Edit_Proxies);
--  Elaboration of the proxy tagged type package register proxy object
--  constructor. Bindings must be able to create proxy object of the
--  corresponding tagged type for works properly.

package body Qt4.Plain_Text_Edits is

   function backgroundVisible_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.bool;
   pragma Import (C, backgroundVisible_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_backgroundVisible_0_wrapper");

   function blockCount_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.bool;
   pragma Import (C, blockCount_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_blockCount_0_wrapper");

   function canPaste_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.bool;
   pragma Import (C, canPaste_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_canPaste_0_wrapper");

   function centerOnScroll_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.bool;
   pragma Import (C, centerOnScroll_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_centerOnScroll_0_wrapper");

   function createStandardContextMenu_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return not null access Qt_Ada.Internals.Objects.QObject;
   pragma Import (C, createStandardContextMenu_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_createStandardContextMenu_0_wrapper");

   procedure currentCharFormat_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Returns : not null access Qt4.Text_Formats.Internals.QTextFormat);
   pragma Import (C, currentCharFormat_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_currentCharFormat_0_wrapper");

   procedure cursorForPosition_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Pos : not null access constant Qt4.Points.Internals.QPoint;
     Returns : out Qt4.Text_Cursors.Thin.QTextCursor);
   pragma Import (C, cursorForPosition_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_cursorForPosition_0_wrapper");

   procedure cursorRect_1_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Cursor : not null access constant Qt4.Text_Cursors.Thin.QTextCursor;
     Returns : not null access Qt4.Rects.Internals.QRect);
   pragma Import (C, cursorRect_1_wrapper,
                     "__Qt4Ada_QPlainTextEdit_cursorRect_1_wrapper");

   procedure cursorRect_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Returns : not null access Qt4.Rects.Internals.QRect);
   pragma Import (C, cursorRect_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_cursorRect_0_wrapper");

   function cursorWidth_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.Q_Integer;
   pragma Import (C, cursorWidth_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_cursorWidth_0_wrapper");

   function document_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return not null access Qt_Ada.Internals.Objects.QObject;
   pragma Import (C, document_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_document_0_wrapper");

   procedure documentTitle_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Returns : not null access Qt4.Strings.Internals.QString);
   pragma Import (C, documentTitle_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_documentTitle_0_wrapper");

   procedure ensureCursorVisible_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, ensureCursorVisible_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_ensureCursorVisible_0_wrapper");

   function isReadOnly_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.bool;
   pragma Import (C, isReadOnly_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_isReadOnly_0_wrapper");

   function isUndoRedoEnabled_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.bool;
   pragma Import (C, isUndoRedoEnabled_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_isUndoRedoEnabled_0_wrapper");

   function lineWrapMode_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.Plain_Text_Edits.Plain_Text_Edit_Line_Wrap_Mode;
   pragma Import (C, lineWrapMode_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_lineWrapMode_0_wrapper");

   function maximumBlockCount_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.Q_Integer;
   pragma Import (C, maximumBlockCount_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_maximumBlockCount_0_wrapper");

   procedure mergeCurrentCharFormat_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Modifier : not null access constant Qt4.Text_Formats.Internals.QTextFormat);
   pragma Import (C, mergeCurrentCharFormat_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_mergeCurrentCharFormat_0_wrapper");

   function overwriteMode_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.bool;
   pragma Import (C, overwriteMode_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_overwriteMode_0_wrapper");

   procedure setBackgroundVisible_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Visible : Qt4.bool);
   pragma Import (C, setBackgroundVisible_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_setBackgroundVisible_0_wrapper");

   procedure setCenterOnScroll_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Enabled : Qt4.bool);
   pragma Import (C, setCenterOnScroll_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_setCenterOnScroll_0_wrapper");

   procedure setCurrentCharFormat_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Modifier : not null access constant Qt4.Text_Formats.Internals.QTextFormat);
   pragma Import (C, setCurrentCharFormat_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_setCurrentCharFormat_0_wrapper");

   procedure setCursorWidth_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Width : Qt4.Q_Integer);
   pragma Import (C, setCursorWidth_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_setCursorWidth_0_wrapper");

   procedure setDocument_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Document : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, setDocument_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_setDocument_0_wrapper");

   procedure setDocumentTitle_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Title : not null access constant Qt4.Strings.Internals.QString);
   pragma Import (C, setDocumentTitle_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_setDocumentTitle_0_wrapper");

   procedure setLineWrapMode_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Mode : Qt4.Plain_Text_Edits.Plain_Text_Edit_Line_Wrap_Mode);
   pragma Import (C, setLineWrapMode_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_setLineWrapMode_0_wrapper");

   procedure setMaximumBlockCount_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Maximum : Qt4.Q_Integer);
   pragma Import (C, setMaximumBlockCount_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_setMaximumBlockCount_0_wrapper");

   procedure setOverwriteMode_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Overwrite : Qt4.bool);
   pragma Import (C, setOverwriteMode_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_setOverwriteMode_0_wrapper");

   procedure setReadOnly_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Ro : Qt4.bool);
   pragma Import (C, setReadOnly_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_setReadOnly_0_wrapper");

   procedure setTabChangesFocus_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     B : Qt4.bool);
   pragma Import (C, setTabChangesFocus_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_setTabChangesFocus_0_wrapper");

   procedure setTabStopWidth_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Width : Qt4.Q_Integer);
   pragma Import (C, setTabStopWidth_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_setTabStopWidth_0_wrapper");

   procedure setTextCursor_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Cursor : not null access constant Qt4.Text_Cursors.Thin.QTextCursor);
   pragma Import (C, setTextCursor_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_setTextCursor_0_wrapper");

   procedure setUndoRedoEnabled_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Enable : Qt4.bool);
   pragma Import (C, setUndoRedoEnabled_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_setUndoRedoEnabled_0_wrapper");

   function tabChangesFocus_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.bool;
   pragma Import (C, tabChangesFocus_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_tabChangesFocus_0_wrapper");

   function tabStopWidth_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.Q_Integer;
   pragma Import (C, tabStopWidth_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_tabStopWidth_0_wrapper");

   procedure textCursor_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Returns : out Qt4.Text_Cursors.Thin.QTextCursor);
   pragma Import (C, textCursor_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_textCursor_0_wrapper");

   procedure toPlainText_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Returns : not null access Qt4.Strings.Internals.QString);
   pragma Import (C, toPlainText_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_toPlainText_0_wrapper");

   function wordWrapMode_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.Text_Options.Text_Option_Wrap_Mode;
   pragma Import (C, wordWrapMode_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_wordWrapMode_0_wrapper");

   procedure appendHtml_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Html : not null access constant Qt4.Strings.Internals.QString);
   pragma Import (C, appendHtml_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_appendHtml_0_wrapper");

   procedure appendPlainText_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Text : not null access constant Qt4.Strings.Internals.QString);
   pragma Import (C, appendPlainText_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_appendPlainText_0_wrapper");

   procedure centerCursor_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, centerCursor_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_centerCursor_0_wrapper");

   procedure clear_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, clear_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_clear_0_wrapper");

   procedure copy_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, copy_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_copy_0_wrapper");

   procedure cut_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, cut_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_cut_0_wrapper");

   procedure insertPlainText_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Text : not null access constant Qt4.Strings.Internals.QString);
   pragma Import (C, insertPlainText_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_insertPlainText_0_wrapper");

   procedure paste_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, paste_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_paste_0_wrapper");

   procedure redo_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, redo_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_redo_0_wrapper");

   procedure selectAll_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, selectAll_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_selectAll_0_wrapper");

   procedure setPlainText_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Text : not null access constant Qt4.Strings.Internals.QString);
   pragma Import (C, setPlainText_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_setPlainText_0_wrapper");

   procedure undo_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, undo_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_undo_0_wrapper");

   procedure moveCursor
    (Self      : not null access Qt_Ada.Internals.Objects.QObject;
     Operation : Qt4.Text_Cursors.Move_Operation;
     Mode      : Qt4.Text_Cursors.Move_Mode);
   pragma Import
    (C, moveCursor,
     "__QtAda_QPlainTextEdit_QTextCursorMoveOperation_QTextCursorMoveMode");

   -----------------
   -- Move_Cursor --
   -----------------

   procedure Move_Cursor
    (Self      : not null access Q_Plain_Text_Edit'Class;
     Operation : Qt4.Text_Cursors.Move_Operation;
     Mode      : Qt4.Text_Cursors.Move_Mode := Qt4.Text_Cursors.Move_Anchor)
   is
   begin
      moveCursor (Self.QObject_View, Operation, Mode);
   end Move_Cursor;

   pragma Style_Checks ("N");

   ------------------------
   -- Background_Visible --
   ------------------------

   function Background_Visible
    (Self : not null access constant Q_Plain_Text_Edit'Class)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (backgroundVisible_0_wrapper
           (Self.QObject_View));
   end Background_Visible;

   -----------------
   -- Block_Count --
   -----------------

   function Block_Count
    (Self : not null access constant Q_Plain_Text_Edit'Class)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (blockCount_0_wrapper
           (Self.QObject_View));
   end Block_Count;

   ---------------
   -- Can_Paste --
   ---------------

   function Can_Paste
    (Self : not null access constant Q_Plain_Text_Edit'Class)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (canPaste_0_wrapper
           (Self.QObject_View));
   end Can_Paste;

   ----------------------
   -- Center_On_Scroll --
   ----------------------

   function Center_On_Scroll
    (Self : not null access constant Q_Plain_Text_Edit'Class)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (centerOnScroll_0_wrapper
           (Self.QObject_View));
   end Center_On_Scroll;

   ----------------------------------
   -- Create_Standard_Context_Menu --
   ----------------------------------

   function Create_Standard_Context_Menu
    (Self : not null access Q_Plain_Text_Edit'Class)
       return not null access Qt4.Menus.Q_Menu'Class
   is
   begin
      return
        Qt4.Menus.Q_Menu'Class
         (Qt_Ada.Internals.Object_Registry.To_Q_Object
           (createStandardContextMenu_0_wrapper
             (Self.QObject_View)).all)'Access;
   end Create_Standard_Context_Menu;

   -------------------------
   -- Current_Char_Format --
   -------------------------

   function Current_Char_Format
    (Self : not null access constant Q_Plain_Text_Edit'Class)
       return Qt4.Text_Char_Formats.Q_Text_Char_Format
   is
      Returns : Qt4.Text_Char_Formats.Q_Text_Char_Format;

   begin
      currentCharFormat_0_wrapper
       (Self.QObject_View,
        Qt4.Text_Formats.Internals.QTextFormat_View (Returns));

      return Returns;
   end Current_Char_Format;

   -------------------------
   -- Cursor_For_Position --
   -------------------------

   function Cursor_For_Position
    (Self : not null access constant Q_Plain_Text_Edit'Class;
     Pos : Qt4.Points.Q_Point)
       return Qt4.Text_Cursors.Q_Text_Cursor
   is
      Returns : Qt4.Text_Cursors.Q_Text_Cursor;

   begin
      cursorForPosition_0_wrapper
       (Self.QObject_View,
        Qt4.Points.Internals.QPoint_View (Pos),
        Qt4.Text_Cursors.Internals.QTextCursor_View (Returns).all);

      return Returns;
   end Cursor_For_Position;

   -----------------
   -- Cursor_Rect --
   -----------------

   function Cursor_Rect
    (Self : not null access constant Q_Plain_Text_Edit'Class;
     Cursor : Qt4.Text_Cursors.Q_Text_Cursor)
       return Qt4.Rects.Q_Rect
   is
      Returns : Qt4.Rects.Q_Rect;

   begin
      cursorRect_1_wrapper
       (Self.QObject_View,
        Qt4.Text_Cursors.Internals.QTextCursor_View (Cursor),
        Qt4.Rects.Internals.QRect_View (Returns));

      return Returns;
   end Cursor_Rect;

   -----------------
   -- Cursor_Rect --
   -----------------

   function Cursor_Rect
    (Self : not null access constant Q_Plain_Text_Edit'Class)
       return Qt4.Rects.Q_Rect
   is
      Returns : Qt4.Rects.Q_Rect;

   begin
      cursorRect_0_wrapper
       (Self.QObject_View,
        Qt4.Rects.Internals.QRect_View (Returns));

      return Returns;
   end Cursor_Rect;

   ------------------
   -- Cursor_Width --
   ------------------

   function Cursor_Width
    (Self : not null access constant Q_Plain_Text_Edit'Class)
       return Qt4.Q_Integer
   is
   begin
      return
        cursorWidth_0_wrapper
         (Self.QObject_View);
   end Cursor_Width;

   --------------
   -- Document --
   --------------

   function Document
    (Self : not null access constant Q_Plain_Text_Edit'Class)
       return not null access Qt4.Text_Documents.Q_Text_Document'Class
   is
   begin
      return
        Qt4.Text_Documents.Q_Text_Document'Class
         (Qt_Ada.Internals.Object_Registry.To_Q_Object
           (document_0_wrapper
             (Self.QObject_View)).all)'Access;
   end Document;

   --------------------
   -- Document_Title --
   --------------------

   function Document_Title
    (Self : not null access constant Q_Plain_Text_Edit'Class)
       return Qt4.Strings.Q_String
   is
      Returns : Qt4.Strings.Q_String;

   begin
      documentTitle_0_wrapper
       (Self.QObject_View,
        Qt4.Strings.Internals.QString_View (Returns));

      return Returns;
   end Document_Title;

   ---------------------------
   -- Ensure_Cursor_Visible --
   ---------------------------

   procedure Ensure_Cursor_Visible
    (Self : not null access Q_Plain_Text_Edit'Class)
   is
   begin
      ensureCursorVisible_0_wrapper
       (Self.QObject_View);
   end Ensure_Cursor_Visible;

   ------------------
   -- Is_Read_Only --
   ------------------

   function Is_Read_Only
    (Self : not null access constant Q_Plain_Text_Edit'Class)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (isReadOnly_0_wrapper
           (Self.QObject_View));
   end Is_Read_Only;

   --------------------------
   -- Is_Undo_Redo_Enabled --
   --------------------------

   function Is_Undo_Redo_Enabled
    (Self : not null access constant Q_Plain_Text_Edit'Class)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (isUndoRedoEnabled_0_wrapper
           (Self.QObject_View));
   end Is_Undo_Redo_Enabled;

   --------------------
   -- Line_Wrap_Mode --
   --------------------

   function Line_Wrap_Mode
    (Self : not null access constant Q_Plain_Text_Edit'Class)
       return Qt4.Plain_Text_Edits.Plain_Text_Edit_Line_Wrap_Mode
   is
   begin
      return
        lineWrapMode_0_wrapper
         (Self.QObject_View);
   end Line_Wrap_Mode;

   -------------------------
   -- Maximum_Block_Count --
   -------------------------

   function Maximum_Block_Count
    (Self : not null access constant Q_Plain_Text_Edit'Class)
       return Qt4.Q_Integer
   is
   begin
      return
        maximumBlockCount_0_wrapper
         (Self.QObject_View);
   end Maximum_Block_Count;

   -------------------------------
   -- Merge_Current_Char_Format --
   -------------------------------

   procedure Merge_Current_Char_Format
    (Self : not null access Q_Plain_Text_Edit'Class;
     Modifier : Qt4.Text_Char_Formats.Q_Text_Char_Format'Class)
   is
   begin
      mergeCurrentCharFormat_0_wrapper
       (Self.QObject_View,
        Qt4.Text_Formats.Internals.QTextFormat_View (Modifier));
   end Merge_Current_Char_Format;

   --------------------
   -- Overwrite_Mode --
   --------------------

   function Overwrite_Mode
    (Self : not null access constant Q_Plain_Text_Edit'Class)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (overwriteMode_0_wrapper
           (Self.QObject_View));
   end Overwrite_Mode;

   ----------------------------
   -- Set_Background_Visible --
   ----------------------------

   procedure Set_Background_Visible
    (Self : not null access Q_Plain_Text_Edit'Class;
     Visible : Standard.Boolean)
   is
   begin
      setBackgroundVisible_0_wrapper
       (Self.QObject_View,
        Qt4.To_bool (Visible));
   end Set_Background_Visible;

   --------------------------
   -- Set_Center_On_Scroll --
   --------------------------

   procedure Set_Center_On_Scroll
    (Self : not null access Q_Plain_Text_Edit'Class;
     Enabled : Standard.Boolean)
   is
   begin
      setCenterOnScroll_0_wrapper
       (Self.QObject_View,
        Qt4.To_bool (Enabled));
   end Set_Center_On_Scroll;

   -----------------------------
   -- Set_Current_Char_Format --
   -----------------------------

   procedure Set_Current_Char_Format
    (Self : not null access Q_Plain_Text_Edit'Class;
     Modifier : Qt4.Text_Char_Formats.Q_Text_Char_Format'Class)
   is
   begin
      setCurrentCharFormat_0_wrapper
       (Self.QObject_View,
        Qt4.Text_Formats.Internals.QTextFormat_View (Modifier));
   end Set_Current_Char_Format;

   ----------------------
   -- Set_Cursor_Width --
   ----------------------

   procedure Set_Cursor_Width
    (Self : not null access Q_Plain_Text_Edit'Class;
     Width : Qt4.Q_Integer)
   is
   begin
      setCursorWidth_0_wrapper
       (Self.QObject_View,
        Width);
   end Set_Cursor_Width;

   ------------------
   -- Set_Document --
   ------------------

   procedure Set_Document
    (Self : not null access Q_Plain_Text_Edit'Class;
     Document : not null access Qt4.Text_Documents.Q_Text_Document'Class)
   is
   begin
      setDocument_0_wrapper
       (Self.QObject_View,
        Document.QObject_View);
   end Set_Document;

   ------------------------
   -- Set_Document_Title --
   ------------------------

   procedure Set_Document_Title
    (Self : not null access Q_Plain_Text_Edit'Class;
     Title : Qt4.Strings.Q_String)
   is
   begin
      setDocumentTitle_0_wrapper
       (Self.QObject_View,
        Qt4.Strings.Internals.QString_View (Title));
   end Set_Document_Title;

   ------------------------
   -- Set_Line_Wrap_Mode --
   ------------------------

   procedure Set_Line_Wrap_Mode
    (Self : not null access Q_Plain_Text_Edit'Class;
     Mode : Qt4.Plain_Text_Edits.Plain_Text_Edit_Line_Wrap_Mode)
   is
   begin
      setLineWrapMode_0_wrapper
       (Self.QObject_View,
        Mode);
   end Set_Line_Wrap_Mode;

   -----------------------------
   -- Set_Maximum_Block_Count --
   -----------------------------

   procedure Set_Maximum_Block_Count
    (Self : not null access Q_Plain_Text_Edit'Class;
     Maximum : Qt4.Q_Integer)
   is
   begin
      setMaximumBlockCount_0_wrapper
       (Self.QObject_View,
        Maximum);
   end Set_Maximum_Block_Count;

   ------------------------
   -- Set_Overwrite_Mode --
   ------------------------

   procedure Set_Overwrite_Mode
    (Self : not null access Q_Plain_Text_Edit'Class;
     Overwrite : Standard.Boolean)
   is
   begin
      setOverwriteMode_0_wrapper
       (Self.QObject_View,
        Qt4.To_bool (Overwrite));
   end Set_Overwrite_Mode;

   -------------------
   -- Set_Read_Only --
   -------------------

   procedure Set_Read_Only
    (Self : not null access Q_Plain_Text_Edit'Class;
     Ro : Standard.Boolean)
   is
   begin
      setReadOnly_0_wrapper
       (Self.QObject_View,
        Qt4.To_bool (Ro));
   end Set_Read_Only;

   ---------------------------
   -- Set_Tab_Changes_Focus --
   ---------------------------

   procedure Set_Tab_Changes_Focus
    (Self : not null access Q_Plain_Text_Edit'Class;
     B : Standard.Boolean)
   is
   begin
      setTabChangesFocus_0_wrapper
       (Self.QObject_View,
        Qt4.To_bool (B));
   end Set_Tab_Changes_Focus;

   ------------------------
   -- Set_Tab_Stop_Width --
   ------------------------

   procedure Set_Tab_Stop_Width
    (Self : not null access Q_Plain_Text_Edit'Class;
     Width : Qt4.Q_Integer)
   is
   begin
      setTabStopWidth_0_wrapper
       (Self.QObject_View,
        Width);
   end Set_Tab_Stop_Width;

   ---------------------
   -- Set_Text_Cursor --
   ---------------------

   procedure Set_Text_Cursor
    (Self : not null access Q_Plain_Text_Edit'Class;
     Cursor : Qt4.Text_Cursors.Q_Text_Cursor)
   is
   begin
      setTextCursor_0_wrapper
       (Self.QObject_View,
        Qt4.Text_Cursors.Internals.QTextCursor_View (Cursor));
   end Set_Text_Cursor;

   ---------------------------
   -- Set_Undo_Redo_Enabled --
   ---------------------------

   procedure Set_Undo_Redo_Enabled
    (Self : not null access Q_Plain_Text_Edit'Class;
     Enable : Standard.Boolean)
   is
   begin
      setUndoRedoEnabled_0_wrapper
       (Self.QObject_View,
        Qt4.To_bool (Enable));
   end Set_Undo_Redo_Enabled;

   -----------------------
   -- Tab_Changes_Focus --
   -----------------------

   function Tab_Changes_Focus
    (Self : not null access constant Q_Plain_Text_Edit'Class)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (tabChangesFocus_0_wrapper
           (Self.QObject_View));
   end Tab_Changes_Focus;

   --------------------
   -- Tab_Stop_Width --
   --------------------

   function Tab_Stop_Width
    (Self : not null access constant Q_Plain_Text_Edit'Class)
       return Qt4.Q_Integer
   is
   begin
      return
        tabStopWidth_0_wrapper
         (Self.QObject_View);
   end Tab_Stop_Width;

   -----------------
   -- Text_Cursor --
   -----------------

   function Text_Cursor
    (Self : not null access constant Q_Plain_Text_Edit'Class)
       return Qt4.Text_Cursors.Q_Text_Cursor
   is
      Returns : Qt4.Text_Cursors.Q_Text_Cursor;

   begin
      textCursor_0_wrapper
       (Self.QObject_View,
        Qt4.Text_Cursors.Internals.QTextCursor_View (Returns).all);

      return Returns;
   end Text_Cursor;

   -------------------
   -- To_Plain_Text --
   -------------------

   function To_Plain_Text
    (Self : not null access constant Q_Plain_Text_Edit'Class)
       return Qt4.Strings.Q_String
   is
      Returns : Qt4.Strings.Q_String;

   begin
      toPlainText_0_wrapper
       (Self.QObject_View,
        Qt4.Strings.Internals.QString_View (Returns));

      return Returns;
   end To_Plain_Text;

   --------------------
   -- Word_Wrap_Mode --
   --------------------

   function Word_Wrap_Mode
    (Self : not null access constant Q_Plain_Text_Edit'Class)
       return Qt4.Text_Options.Text_Option_Wrap_Mode
   is
   begin
      return
        wordWrapMode_0_wrapper
         (Self.QObject_View);
   end Word_Wrap_Mode;

   -----------------
   -- Append_Html --
   -----------------

   procedure Append_Html
    (Self : not null access Q_Plain_Text_Edit'Class;
     Html : Qt4.Strings.Q_String)
   is
   begin
      appendHtml_0_wrapper
       (Self.QObject_View,
        Qt4.Strings.Internals.QString_View (Html));
   end Append_Html;

   -----------------------
   -- Append_Plain_Text --
   -----------------------

   procedure Append_Plain_Text
    (Self : not null access Q_Plain_Text_Edit'Class;
     Text : Qt4.Strings.Q_String)
   is
   begin
      appendPlainText_0_wrapper
       (Self.QObject_View,
        Qt4.Strings.Internals.QString_View (Text));
   end Append_Plain_Text;

   -------------------
   -- Center_Cursor --
   -------------------

   procedure Center_Cursor
    (Self : not null access Q_Plain_Text_Edit'Class)
   is
   begin
      centerCursor_0_wrapper
       (Self.QObject_View);
   end Center_Cursor;

   -----------
   -- Clear --
   -----------

   procedure Clear
    (Self : not null access Q_Plain_Text_Edit'Class)
   is
   begin
      clear_0_wrapper
       (Self.QObject_View);
   end Clear;

   ----------
   -- Copy --
   ----------

   procedure Copy
    (Self : not null access Q_Plain_Text_Edit'Class)
   is
   begin
      copy_0_wrapper
       (Self.QObject_View);
   end Copy;

   ---------
   -- Cut --
   ---------

   procedure Cut
    (Self : not null access Q_Plain_Text_Edit'Class)
   is
   begin
      cut_0_wrapper
       (Self.QObject_View);
   end Cut;

   -----------------------
   -- Insert_Plain_Text --
   -----------------------

   procedure Insert_Plain_Text
    (Self : not null access Q_Plain_Text_Edit'Class;
     Text : Qt4.Strings.Q_String)
   is
   begin
      insertPlainText_0_wrapper
       (Self.QObject_View,
        Qt4.Strings.Internals.QString_View (Text));
   end Insert_Plain_Text;

   -----------
   -- Paste --
   -----------

   procedure Paste
    (Self : not null access Q_Plain_Text_Edit'Class)
   is
   begin
      paste_0_wrapper
       (Self.QObject_View);
   end Paste;

   ----------
   -- Redo --
   ----------

   procedure Redo
    (Self : not null access Q_Plain_Text_Edit'Class)
   is
   begin
      redo_0_wrapper
       (Self.QObject_View);
   end Redo;

   ----------------
   -- Select_All --
   ----------------

   procedure Select_All
    (Self : not null access Q_Plain_Text_Edit'Class)
   is
   begin
      selectAll_0_wrapper
       (Self.QObject_View);
   end Select_All;

   --------------------
   -- Set_Plain_Text --
   --------------------

   procedure Set_Plain_Text
    (Self : not null access Q_Plain_Text_Edit'Class;
     Text : Qt4.Strings.Q_String)
   is
   begin
      setPlainText_0_wrapper
       (Self.QObject_View,
        Qt4.Strings.Internals.QString_View (Text));
   end Set_Plain_Text;

   ----------
   -- Undo --
   ----------

   procedure Undo
    (Self : not null access Q_Plain_Text_Edit'Class)
   is
   begin
      undo_0_wrapper
       (Self.QObject_View);
   end Undo;

end Qt4.Plain_Text_Edits;
